#include <iostream>
#include <cassert>
#include "SafeArray4.h"

using namespace std;

int SafeArray::at(int i) const
{
    assert((i >= 0) && (i < length));
    return elements[i];
}

void SafeArray::set(int i, int value)
{
    assert((i >= 0) && (i < length));
    elements[i] = value;
}

SafeArray& SafeArray::operator =(const SafeArray& rhs)
{
    if (this == &rhs) return *this;
    if (elements != nullptr) delete[] elements;

    length = rhs.length;

    int *dummy = new int[length];
    for (int i = 0; i < length; i++) dummy[i] = 100*i;

    elements = new int[length];

    for (int i = 0; i < length; i++)
    {
        elements[i] = rhs.elements[i];
    }

    return *this;
}
